<?php
/**
 * Copyright (C) 2015 Panther (https://www.pantherforum.org)
 * based on code by FluxBB copyright (C) 2008-2012 FluxBB
 * License: http://www.gnu.org/licenses/gpl.html GPL version 3 or higher
 */

// Make sure no one attempts to run this script "directly"
if (!defined('PANTHER'))
    exit;

$panther_url = array(
    'insertion_find' => '.html',
    'insertion_replace' => '$1.html',
    'change_email' => 'change-email$1.html',
    'change_email_key' => 'change-email-$1-$2.html',
    'change_password' => 'change-pass-$1.html',
    'upload_avatar' => 'upload-avatar/$1/$2.html',
    'use_gravatar' => 'use-gravatar/$1/$2.html',
    'change_password_key' => 'change-pass$1-$2.html',
    'delete' => 'delete/$1.html',
    'delete_avatar' => 'delete-avatar/$1/$2.html',
    'edit' => 'edit/$1.html',
    'edit_edit' => 'edit$1-edit.html',
    'email' => 'email/$1.html',
    'forum' => 'forum/$1-$2.html',
    'forum_paginate' => 'forum/$1-$2.html',
    'forum_noid' => 'forum/.html',
    'forum_page' => 'forum/$1-$3/p$2.html',
    'attachment' => 'attachment/$1.html',
    'attachment_download' => 'attachment/download/$1.html',
    'online' => 'online.html',
    'index' => 'index.html',
    'inbox' => 'pms-inbox.html',
    'box' => 'pms-inbox/$1.html',
    'pms_delete' => 'pms-delete/$1.html',
    'pms_folders' => 'pms-folders.html',
    'pms_blocked' => 'pms-blocked.html',
    'pms_edit' => 'pms-edit/$1.html',
    'pms_quote' => 'pms-send/$1/$2.html',
    'pms_view' => 'pms-view/$1.html',
    'pms_paginate' => 'pms-view/$1.html',
    'pms_post' => 'pms-post/$1.html#p$1',
    'pms_reply' => 'pms-send/$1.html',
    'pms_new' => 'pms-view/$1/new.html',
    'pms_last' => 'pms-view/$1/last.html',
    'send_message' => 'pms-send.html',
    'leaders' => 'the-moderating-team.html',
    'forum_subscribe' => 'subscribe/forum/$1/$2.html',
    'forum_unsubscribe' => 'unsubscribe/forum/$1/$2.html',
    'index_rss' => 'feed/rss.xml',
    'index_atom' => 'feed/atom.xml',
    'topic_rss' => 'feed/rss/tid/$1.xml',
    'topic_atom' => 'feed/atom/tid/$1.xml',
    'forum_rss' => 'feed/rss/fid/$1.xml',
    'forum_atom' => 'feed/atom/fid/$1.xml',
    'login' => 'login.html',
    'login_in' => 'login-do.html',
    'logout' => 'logout/$1/$2.html',
    'mark_read' => 'markread/$1.html',
    'mark_forum_read' => 'mark-forum-read/$1/$2.html',
    'new_topic' => 'post-topic/$1.html',
    'new_reply' => 'post-reply/$1.html',
    'quote' => 'post-reply/$1/$2.html',
    'post' => 'post/$1.html#p$1',
    'profile' => 'user/$1-$2.html',
    'profile_essentials' => 'profile-$1/essentials.html',
    'profile_personal' => 'profile-$1/personal.html',
    'profile_messaging' => 'profile-$1/messaging.html',
    'profile_personality' => 'profile-$1/personality.html',
    'profile_display' => 'profile-$1/display.html',
    'profile_privacy' => 'profile-$1/privacy.html',
    'profile_rep_received' => 'profile-$1/rep_received.html',
    'profile_rep_given' => 'profile-$1/rep_given.html',
    'profile_view' => 'profile-$1/view.html',
    'profile_admin' => 'profile-$1/admin.html',
    'register' => 'register.html',
    'register_register' => 'register-do.html',
    'report' => 'report/$1.html',
    'request_password' => 'request-password.html',
    'rules' => 'rules.html',
    'search' => 'search.html',
    'search_cache' => 'search/$1.html',
    'search_pagination' => 'search/$1-.html',
    'search_unanswered' => 'show-unanswered.html',
    'search_result' => 'search.html?action=search&amp;keywords=$1&amp;author=$2&amp;forums=$3&amp;search_in=$4&amp;sort_by=$5&amp;sort_dir=$6&amp;show_as=$7',
    'search_new' => 'show-new.html',
    'search_replies' => 'show-replies.html',
    'search_recent' => 'show-recent.html',
    'profile_promote' => 'promote/$1-$2-$3.html',
    'search_new_results' => 'show-new-posts/$1.html',
    'search_subscriptions' => 'show-subscriptions$1.html',
    'search_user_posts' => 'show-user-posts$1.html',
    'search_user_topics' => 'show-user-topics$1.html',
    'topic_subscribe' => 'subscribe/topic/$1/$2.html',
    'topic_paginate' => 'topic/$1-$2.html',
    'topic' => 'topic/$1-$2.html',
    'topic_new_posts' => 'topic/$1-$2/new.html',
    'topic_page' => 'topic/$1-$2/p$3.html',
    'topic_last_post' => 'topic/$1-$3-$2/last.html',
    'topic_unsubscribe' => 'unsubscribe/topic/$1/$2.html',
	'poll_add' => 'poll/add/id/$1.html',
    'poll_vote' => 'poll/vote.html',
    'poll_reset' => 'poll/misc/reset/$1.html',
    'poll_delete' => 'poll/misc/delete/$1.html',
    'poll_edit' => 'poll/misc/edit/$1.html',
    'userlist' => 'userlist.html',
    'userlist_group' => 'show-group/$1.html',
    'userlist_result' => 'userlist.html?username=$1&show_group=$2&sort_by=$3&sort_dir=$4',
    'page' => 'p$1',
    'moderate_forum' => 'moderate-forum/$1.html',
    'moderate_forum_p' => 'moderate-forum/$1/p$2.html',
    'moderate_topic_p' => 'moderate-forum/$1/topic/$2/p$3.html',
    'get_host' => PANTHER_ADMIN_DIR.'/get-host-$1.html',
    'help' => 'help.html#$1',
    'unapprove' => 'moderate-forum/$1/unapprove/$2/$3.html',
    'move' => 'moderate-forum/$1/move_topics/$2/$3.html',
    'open' => 'moderate-forum/$1/open/$2/$3.html',
    'close' => 'moderate-forum/$1/close/$2/$3.html',
    'stick' => 'moderate-forum/$1/stick/$2/$3.html',
    'unarchive' => 'moderate-forum/$1/unarchive/$2/$3.html',
    'archive' => 'moderate-forum/$1/archive/$2/$3.html',
    'unstick' => 'moderate-forum/$1/unstick/$2/$3.html',
    'moderate_topic' => 'moderate-forum/$1/topic/$2.html',
    'moderate_all' => 'moderate-forum/$1/topic/$2/all.html',
    'moderate_multi' => 'moderate-forum/$1/multi_moderate/$2/$3.html',
    'admin_index' => PANTHER_ADMIN_DIR.'/index.html',
    'admin_bans' => PANTHER_ADMIN_DIR.'/bans.html',
    'admin_categories' => PANTHER_ADMIN_DIR.'/categories.html',
    'admin_permissions' => PANTHER_ADMIN_DIR.'/permissions.html',
    'admin_censoring' => PANTHER_ADMIN_DIR.'/censoring.html',
    'admin_forums' => PANTHER_ADMIN_DIR.'/forums.html',
    'admin_groups' => PANTHER_ADMIN_DIR.'/groups.html',
    'admin_loader' => PANTHER_ADMIN_DIR.'/loader.html?plugin=$1',
    'admin_maintenance' => PANTHER_ADMIN_DIR.'/maintenance.html',
    'admin_options' => PANTHER_ADMIN_DIR.'/options.html',
    'admin_ranks' => PANTHER_ADMIN_DIR.'/ranks.html',
    'admin_deleted' => PANTHER_ADMIN_DIR.'/deleted.html',
    'admin_reports' => PANTHER_ADMIN_DIR.'/reports.html',
    'admin_announcements' => PANTHER_ADMIN_DIR.'/announcements.html',
    'announcement_fid' => 'forum-$2/announcement-$1-$3.html',
    'announcement' => 'forum-$2/announcement-$1.html',
    'admin_posts' => PANTHER_ADMIN_DIR.'/posts.html',
    'admin_moderate' => PANTHER_ADMIN_DIR.'/moderate.html',
    'admin_attachments' => PANTHER_ADMIN_DIR.'/attachments.html',
    'admin_users' => PANTHER_ADMIN_DIR.'/users.html',
    'admin_archive' => PANTHER_ADMIN_DIR.'/archive.html',
    'admin_smilies' => PANTHER_ADMIN_DIR.'/smilies.html',
    'admin_robots' => PANTHER_ADMIN_DIR.'/robots.html',
    'admin_updates' => PANTHER_ADMIN_DIR.'/updates.html',
	'admin_tasks' => PANTHER_ADMIN_DIR.'/tasks.html',
    'delete_task' => PANTHER_ADMIN_DIR.'/delete-task/$1.html',
    'edit_task' => PANTHER_ADMIN_DIR.'/edit-task/$1.html',
    'admin_restrictions' => PANTHER_ADMIN_DIR.'/restrictions.html',
    'admin_statistics' => PANTHER_ADMIN_DIR.'/statistics.html',
    'admin_forums_action' => PANTHER_ADMIN_DIR.'/forums-$1.html',
    'add_announcement' => PANTHER_ADMIN_DIR.'/add-announcements.html',
    'edit_announcement' => PANTHER_ADMIN_DIR.'/edit-announcements$1.html',
    'delete_announcement' => PANTHER_ADMIN_DIR.'/delete-announcements$1.html',
    'upload_image' => PANTHER_ADMIN_DIR.'/upload-image$1.html',
    'delete_image' => PANTHER_ADMIN_DIR.'/delete-image$1.html',
    'edit_forum' => PANTHER_ADMIN_DIR.'/edit-forum$1.html',
    'del_forum' => PANTHER_ADMIN_DIR.'/del-forum$1.html',
    'del_group' => PANTHER_ADMIN_DIR.'/delete-group$1.html',
    'edit_group' => PANTHER_ADMIN_DIR.'/edit-group$1.html',
    'admin_options_direct' => PANTHER_ADMIN_DIR.'/options.html#$1',
    'remove_install_file' => PANTHER_ADMIN_DIR.'/remove_install_file.html',
    'enable_extension' => PANTHER_ADMIN_DIR.'/addons/enable/$1.html',
    'disable_extension' => PANTHER_ADMIN_DIR.'/addons/disable/$1.html',
	'uninstall_extension' => PANTHER_ADMIN_DIR.'/addons/uninstall/$1.html',
	'install_extension' => PANTHER_ADMIN_DIR.'/addons/install/$1.html',
    'check_upgrade' => PANTHER_ADMIN_DIR.'/check_upgrade.html',
    'phpinfo' => PANTHER_ADMIN_DIR.'/phpinfo.html',
    'save_notes' => PANTHER_ADMIN_DIR.'/save_notes.html',
    'admin_moderate_add' => PANTHER_ADMIN_DIR.'/add-moderate.html',
    'admin_moderate_edit' => PANTHER_ADMIN_DIR.'/edit-moderate$1.html',
    'admin_moderate_delete' => PANTHER_ADMIN_DIR.'/delete-moderate$1.html',
    'admin_restrictions_query' => PANTHER_ADMIN_DIR.'/restrictions.html?$1',
    'admin_reports_zap' => PANTHER_ADMIN_DIR.'/zap-report.html',
    'admin_users_users' => PANTHER_ADMIN_DIR.'/show_users$1.html',
    'admin_users_ip_stats' => PANTHER_ADMIN_DIR.'/ip_stats$1.html',
    'edit_ban' => PANTHER_ADMIN_DIR.'/edit_ban$1.html',
    'del_ban' => PANTHER_ADMIN_DIR.'/delete_ban$1.html',
    'admin_bans_add' => PANTHER_ADMIN_DIR.'/add_ban$1.html',
    'more_bans' => PANTHER_ADMIN_DIR.'/more-ban-options.html',
    'admin_warnings' => PANTHER_ADMIN_DIR.'/warnings.html',
    'admin_addons' => PANTHER_ADMIN_DIR.'/addons.html',
    'warning_del_level' => PANTHER_ADMIN_DIR.'/del_level/$1.html',
    'warning_edit_level' => PANTHER_ADMIN_DIR.'/edit_level/$1.html',
    'warning_del_type' => PANTHER_ADMIN_DIR.'/del_type/$1.html',
    'warning_edit_type' => PANTHER_ADMIN_DIR.'/edit_type/$1.html',
    'warnings_recent' => 'warnings/action/show_recent.html',
    'warnings' => 'warnings.html',
    'warning_view' => 'warnings/view/$1.html',
    'warning_details' => 'warnings/details/$1.html',
    'warn_user' => 'warnings/warn/$1.html',
    'warn_pid' => 'warnings/warn/$1/?pid=$2'
);

$rewrite_rules = array(
	'/^logout[\/]?([0-9]+)[\/]([a-z0-9]+).html?$/i' => 'login.php?action=out&id=$1&csrf_token=$2',
    '/^attachment?[\/]?(download)?([\/])([0-9]+).html?$/i' => 'attachment.php?item=$3&$1',
    '/^feed[\/]?(rss|atom)[\/]?(fid|tid)[\/]?([0-9]+).xml?$/i' => 'extern.php?action=feed&$2=$3&type=$1',
    '/^feed[\/]?(rss|atom).xml?$/i' => 'extern.php?action=feed&type=$1',
	'/^(help|login|search|register|online|index|warnings).html?$/i' => '$1.php',
	'/^user[\/]([0-9]+)?[-]([a-z0-9-]+).html?$/i' => 'profile.php?id=$1',
    '/^profile[-]?([0-9]+)[\/]([a-z_]+).html?$/i' => 'profile.php?section=$2&id=$1',
    '/^change[-]?(email|pass)?[-]?([0-9]+)[-]([a-zA-Z0-9]+).html?$/i' => 'profile.php?action=change_$1&id=$2&key=$3',
    '/^change[-]?(email|pass)?[-]?([0-9]+).html?$/i' => 'profile.php?action=change_$1&id=$2',
	'/^(delete|edit)?[\/]([0-9]+).html?$/i' => '$1.php?id=$2',
	'/^(delete|upload|use)[-]?(avatar|gravatar)?[\/]?([0-9]+)?[\/]([a-z0-9]+).html?$/i' => 'profile.php?action=$1_$2&id=$3&csrf_token=$4',
    '/^promote[\/]([0-9]+)[-]?([0-9]+)[-]?([a-z0-9-]+).html?$/i' => 'profile.php?action=promote&id=$1&pid=$2&csrf_token=$3',
    '/^edit([0-9]+)[-]?edit.html?$/i' => 'edit.php?action=edit&id=$1',
    '/^post[-]?topic[\/]?([0-9]+).html?$/i' => 'post.php?fid=$1',
    '/^post[-]?reply[\/]?([0-9]+).html?$/i' => 'post.php?tid=$1',
    '/^post[-]?reply[\/]?([0-9]+)[\/]?([0-9]+).html$/i' => 'post.php?tid=$1&qid=$2',
    '/^the[-]moderating[-]team.html?$/i' => 'misc.php?action=leaders',
    '/^(subscribe|unsubscribe)[\/]forum[\/]?([0-9]+)[\/]([a-z0-9]+).html?$/i' => 'misc.php?action=$1&fid=$2&csrf_token=$3',
    '/^(subscribe|unsubscribe)[\/]topic[\/]?([0-9]+)[\/]([a-z0-9]+).html?$/i' => 'misc.php?action=$1&tid=$2&csrf_token=$3',
    '/^rules.html?$/i' => 'misc.php?action=rules',
    '/^markread[\/]([a-z0-9]+).html?$/i' => 'misc.php?action=markread&csrf_token=$1',
    '/^post[\/]?([0-9]+).html?$/i' => 'viewtopic.php?pid=$1',
    '/^(forum|topic)[\/]?([0-9]+)[-]([a-z0-9-]+)[\/]p?[\/]?([0-9]+).html?$/i' => 'view$1.php?id=$2&p=$4',
    '/^(forum|topic)[\/]?([0-9]+)[-]([a-z0-9-]+).html?$/i' => 'view$1.php?id=$2',
    '/^topic[\/]?([0-9]+)[-]([a-z0-9-]+)[\/](new|last).html?$/i' => 'viewtopic.php?id=$1&action=$3',
    '/^forum[-]?([0-9]+)[\/]announcement[-]([0-9]+)(|[-][a-zA-Z0-9-_]+).html?$/i' => 'announcement.php?fid=$1&id=$2&title=$3',
    '/^(email|report)[\/]?([0-9]+)?.html?$/i' => 'misc.php?$1=$2',
    '/^search[\/]?([0-9]+).html?$/i' => 'search.php?search_id=$1',
    '/^search[\/]?([0-9]+)[-]p([0-9]+).html?$/i' => 'search.php?search_id=$1&p=$2',
    '/^show[-]?new[-]posts[\/]([0-9-]+).html?$/i' => 'search.php?action=show_new&fid=$1',
    '/^show[-]?(recent|new|replies|unanswered).html?$/i' => 'search.php?action=show_$1',
    '/^show[-]user[-]?(posts|topics)[-]?([0-9]+).html?$/i' => 'search.php?action=show_user_$1&user_id=$2',
    '/^show[-]?subscriptions[-]?([0-9]+).html?$/i' => 'search.php?action=show_subscriptions&user_id=$1',
    '/^register[-]?do.html?$/i' => 'register.php?action=register',
    '/^login[-]?do.html?$/i' => 'login.php?action=in',
    '/^request[-]?password.html?$/i' => 'login.php?action=forget',
    '/^userlist[\/](|[\/]?p([0-9]+).html)?$/i' => 'userlist.php?p=$2',
    '/^show[-]group[\/]([0-9]+).html?$/i' => 'userlist.php?show_group=$1',
    '/^moderate[-]?forum[\/]([0-9]+).html?$/i' => 'moderate.php?fid=$1',
    '/^moderate[-]?forum[\/]([0-9]+)[\/]?p?[\/]?([0-9]+).html?$/i' => 'moderate.php?fid=$1&p=$3',
    '/^moderate[-]?forum[\/]([0-9]+)[\/]topic[\/]([0-9]+).html?$/i' => 'moderate.php?fid=$1&tid=$2',
    '/^moderate[-]?forum[\/]([0-9]+)[\/]topic[\/]([0-9]+)[\/]all.html?$/i' => 'moderate.php?fid=$1&tid=$2&action=all',
    '/^moderate[-]?forum[\/]([0-9]+)[\/]topic[\/]([0-9]+)[\/]?p?[\/]?([0-9]+).html?$/i' => 'moderate.php?fid=$1&tid=$2&p=$4',
    '/^moderate[-]?forum[\/]([0-9]+)[\/](move_topics|open|close|unstick|stick|multi_moderate|unarchive|archive|unapprove)[\/]([0-9]+)[\/](|[a-z0-9]+).html?$/i' => 'moderate.php?fid=$1&$2=$3&csrf_token=$4',
    '/^poll[\/](add|misc|vote)[\/]?(edit|reset|delete|id|)[\/]?(|[0-9]+).html?$/i' => 'poll_$1.php?$2=$3',
    '/^mark[-]forum[-]read?[\/]([0-9]+)[\/]([a-z0-9]+).html?$/i' => 'misc.php?action=markforumread&fid=$1&csrf_token=$2',
    '/^pms[-]view[\/]?([0-9]+)[\/](new|last).html?$/i' => 'pms_view.php?tid=$1&action=$2',
    '/^pms[-]view[\/]?([0-9]+)[\/]?p([0-9]+).html?$/i' => 'pms_view.php?tid=$1&p=$2',
    '/^pms[-](view|send)[\/]?([0-9]+).html?$/i' => 'pms_$1.php?tid=$2',
    '/^pms[-]send[\/]?([0-9]+)[\/]?([0-9]+).html$/i' => 'pms_send.php?tid=$1&qid=$2',
    '/^pms[-]post[\/]?([0-9]+).html?$/i' => 'pms_view.php?pid=$1#p$1',
    '/^pms[-](delete|edit)[\/]?([0-9]+).html?$/i' => 'pms_misc.php?action=$1&pid=$2',
    '/^pms[-](folders|blocked).html?$/i' => 'pms_misc.php?action=$1',
	'/^pms[-]inbox[\/]?([0-9]+).html?$/i' => 'pms_inbox.php?id=$1',
	'/^pms[-](inbox|send).html?$/i' => 'pms_$1.php',
	'/^warnings[\/](action|view|details|warn)[\/]([a-z_0-9]+).html?$/i' => 'warnings.php?$1=$2',	
    '/^'.PANTHER_ADMIN_DIR.'[\/]?(upload|delete)[-]image([0-9]+).html?$/i' => PANTHER_ADMIN_DIR.'/groups.php?action=$1_image&id=$2',
    '/^'.PANTHER_ADMIN_DIR.'[\/](edit|del)[-]?forum([0-9]+).html?$/i' => PANTHER_ADMIN_DIR.'/forums.php?$1_forum=$2',
    '/^'.PANTHER_ADMIN_DIR.'[\/](edit|delete)[-]?group([0-9]+).html?$/i' => PANTHER_ADMIN_DIR.'/groups.php?$1_group=$2',
    '/^'.PANTHER_ADMIN_DIR.'[\/](remove_install_file|check_upgrade|phpinfo|save_notes).html?$/i' => PANTHER_ADMIN_DIR.'/index.php?action=$1',
    '/^'.PANTHER_ADMIN_DIR.'[\/](add|edit|delete)[-]multi-moderation(|[0-9]+).html?$/i' => PANTHER_ADMIN_DIR.'/moderate.php?action=$1&id=$2',
    '/^'.PANTHER_ADMIN_DIR.'[\/](add|edit|delete)[-](moderate|announcements)(|[0-9]+).html?$/i' => PANTHER_ADMIN_DIR.'/$2.php?action=$1&id=$3',
    '/^'.PANTHER_ADMIN_DIR.'[\/]zap-report.html?$/i' => PANTHER_ADMIN_DIR.'/reports.php?action=zap',
    '/^'.PANTHER_ADMIN_DIR.'[\/](show_users|ip_stats)([0-9]+|[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}+).html?$/i' => PANTHER_ADMIN_DIR.'/users.php?$1=$2',
    '/^'.PANTHER_ADMIN_DIR.'[\/](edit_ban|delete_ban|add_ban)([0-9]+).html?$/i' => PANTHER_ADMIN_DIR.'/bans.php?$1=$2',
    '/^'.PANTHER_ADMIN_DIR.'[\/]more-ban-options.html?$/i' => PANTHER_ADMIN_DIR.'/bans.php?action=more',
    '/^'.PANTHER_ADMIN_DIR.'[\/]get-host[-]?([0-9]+|[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}).html?$/i' => 'moderate.php?get_host=$1',
    '/^'.PANTHER_ADMIN_DIR.'[\/]?(index|bans|categories|users|permissions|censoring|forums|groups|loader|maintenance|options|ranks|reports|posts|moderate|restrictions|statistics|updates|archive|deleted|smilies|warnings|attachments|robots|announcements|addons|tasks).html?$/i' => PANTHER_ADMIN_DIR.'/$1.php',
    '/^'.PANTHER_ADMIN_DIR.'[\/]?forums[-](addel|edit).html?$/i' => PANTHER_ADMIN_DIR.'/forums.php?action=$1',
    '/^'.PANTHER_ADMIN_DIR.'[\/]?(del_level|edit_level|del_type|edit_type)[\/]([0-9]+).html?$/i' => PANTHER_ADMIN_DIR.'/warnings.php?$1=$2',
    '/^'.PANTHER_ADMIN_DIR.'[\/]?(delete|edit)[-]task[\/]([0-9]+).html?$/i' => PANTHER_ADMIN_DIR.'/tasks.php?$1=$2',
    '/^'.PANTHER_ADMIN_DIR.'[\/]?addons[\/](enable|disable|install|uninstall)[\/]([a-z0-9_-]+).html?$/i' => PANTHER_ADMIN_DIR.'/addons.php?action=$1&file=$2',
);