<?php

// Language definitions used in admin_options.php
$lang_admin_options = array(
    
    'Must enter title message' => 'You must enter a board title.',
    'Invalid e-mail message' => 'The admin email address you entered is invalid.',
    'Invalid webmaster e-mail message' => 'The webmaster email address you entered is invalid.',
    'SMTP passwords did not match' => 'You need to enter the SMTP password twice exactly the same to change it.',
    'Enter announcement here' => 'Enter your announcement here.',
    'Enter rules here' => 'Enter your rules here.',
    'Default maintenance message' => 'The forums are temporarily down for maintenance. Please try again in a few minutes.',
    'Timeout error message' => 'The value of "Timeout online" must be smaller than the value of "Timeout visit".',
    'Email name problem' => 'The email name you entered was invalid. This field should contain characters of only  a-z, A-Z or 0-9.',
    
    'Too large ini' => 'The selected file was too large to upload. The server didn\'t allow the upload.',
    'Partial upload' => 'The uploaded file only partially uploaded. Please attempt to upload the file again.',
    'No tmp directory' => 'The server was unable to upload the file to a temporary directory.',
    'No file' => 'You did not select a file to be uploaded.',
    'Bad type' => 'You are not allowed to upload this type of file. Please upload an icon file (.ico).',
    'Options updated redirect' => 'Options updated. Redirecting …',
    'Options head' => 'Options',
    'Too large' => 'The file you tried to upload is larger than the maximum allowed %s bytes.',
    'Too wide or high' => 'The file you tried to upload is wider and/or higher than the maximum allowed %sx%s pixels.',
    
    // Essentials section
    'Essentials subhead' => 'Essentials',
    'Board title label' => 'Board title',
    'Board title help' => 'The title of this bulletin board (shown at the top of every page). This field may <strong>not</strong> contain HTML.',
    'Default avatar label' => 'Default Avatar',
    'Default avatar help' => 'You can change the default avatar here. Select a PNG, JPEG or GIF file from your PC to do so.',
    'Favicon label' => 'Favicon',
    'Favicon help' => 'You can upload a favicon which is displayed in the address bar of a browser, this represents your forum. Select a .ico file from your PC for this. We recommend using <a href="http://realfavicongenerator.net">RealFaviconGenerator</a> for creating favicons.',
    'Board desc label' => 'Board description',
    'Board desc help' => 'A short description of this bulletin board (shown at the top of every page). This field may contain HTML.',
    'URL type label' => 'URL type',
    'URL type help' => 'The type of URLs the board will be set up to use. <strong>Note:</strong> Any \'fancy\' URL schemes require absolute paths for configuration options, and these require the relevant URL to be filled in. If unsure, refer to the documentation.',
    'Default' => 'Default',
    'File based' => 'File based',
    'File based fancy' => 'File based (fancy)',
    'Folder based' => 'Folder based',
    'Folder based fancy' => 'Folder based (fancy)',
    'Base URL label' => 'Base URL',
    'Base URL help' => 'The complete URL of the board without trailing slash (i.e. http://www.mydomain.com/forums). This <strong>must</strong> be correct in order for all links on the forum to work.',
    'Base URL problem' => 'Your installation does not support automatic conversion of internationalized domain names. As your base URL contains special characters, you <strong>must</strong> use an online converter in order to avoid links on the forum from linking to non existant pages.',
    'Timezone label' => 'Default time zone',
    'Timezone help' => 'The default time zone for guests and users attempting to register for the board.',
    'DST label' => 'Adjust for DST',
    'DST help' => 'Check if daylight savings is in effect (advances times by 1 hour).',
    'Language label' => 'Default language',
    'Language help' => 'The default language for guests and users who haven\'t changed from the default in their profile. If you remove a language pack, this must be updated.',
    'Default style label' => 'Default style',
    'Default style help' => 'The default style for guests and users who haven\'t changed from the default in their profile.',
    'Default theme label' => 'Default theme',
    'Default theme help' => 'The default theme for this style. Themes dictate the colour display of the forum based on the style chosen. Note that this will only work on users who have not customised their board style, or guests. It is also possible to change the theme routinely using <a href="%s">Tasks</a>.',
    'Attachments label' => 'Attachments',
    'Attachments help' => 'Allow users to upload attachments with their posts. Attachments can be restricted on a per-usergroup basis.',
    'Max attachments label' => 'Maximum upload size',
    'Max attachments help' => 'The maximum size (in bytes) that users may upload to, not even administartors may bypass this limit.',
    'Attachments orphans label' => 'Create orphans',
    'Attachments orphans help' => 'When a topic is deleted, setting this option to yes will not delete any attachments. Note that if set to no, it may take slightly longer to delete topics or posts.',
    'Attachment icons label' => 'Use icons',
    'Attachment icons help' => 'This will allow the use of icons for attachments. Regardless of this setting, icons are not shown to users who do not view images in posts.',
    'Attachment icon folder label' => 'Icon path',
    'Attachment icon folder help' => 'This is the folder where the attachment icons are stored in (relative or absolute if the field below is filled in).',
    'Attachment icon dir label' => 'Icon URL',
    'Attachment icon dir help' => 'Use this field if attachment icons are stored in a separate place from the forum. Leave blank if the location of attachment icons are relative to the Panther root.',
    'http authentication label' => 'HTTP Authentication',
    'http authentication help' => 'Force administrators and moderators to administer themselves again when accessing the admin panel using HTTP Authentication.',
    'Use editor label' => 'WYSIWYG Editor',
    'Use editor help' => 'Enable the use of a WYSIWYG editor on the forum. Each user can enable or disable the editor if this setting is enabled.',
    'Popular topic label' => 'Popular topic trigger',
    'Popular topic help' => 'The amount of posts in a topic needed to display a popular topic icon instead of the standard topic icon. Set to 0 to disable.',
    'Force ssl label' => 'Force SSL',
    'Force ssl help' => 'Force all users who visit the forum to use the encrypted SSL connection (https). For this to work, your server (and website) must support SSL.',
    'Attachment deny label' => 'Always deny',
    'Attachment deny help' => 'Files with these extensions will always be denied when people try to upload them, except for Administrators, who can override it. Separate extensions with commas.',
    'File extensions label' => 'File Icons',
    'delete full help' => 'This option will permanently delete posts and topics upon deletion instead of allowing moderators and administrators the ability to restore them through administration.',
    'delete full label' => 'Permanently delete',
    'Extensions' => 'File Extensions',
    'Icons' => 'File Icons',
    'Icon options' => 'These fields hold what file extension gets displayed next to which icon. Items are sepereated by commas.',
    'PM receiver label' => 'Max PM receivers',
    'PM receiver help' => 'The maximum amount of participants per personal message. This cannot be overridden by specific group settings.',
    'Polls label' => 'Polls',
    'Polls help' => 'Allow users to add polls to topics on the forum. Polls can be enabled/disabled per user group.',
    'Polls max label' => 'Number of fields',
    'Polls max help' => 'The maximum number of options that will be available for polls.',
    'Attach basefolder label' => 'Attachment location',
    'Attach basefolder help' => 'The location of attachments on the server. This must be the full absolute path to where attachments are located complete with a trailing slash.',
    'Style path label' => 'Style path',
    'Style path help' => 'This field is used when checking for CSS files. This should be relative to the Panther root or absolute if the field below is used.',
    'Style directory label' => 'Style URL',
    'Style directory help' => 'Use this field if CSS scripts are stored in a separate place from the forum. Leave blank if the location of CSS files are relative to the Panther root (and in the default location).',
    
    // Essentials section timezone options
    'UTC-12:00' => '(UTC-12:00) International Date Line West',
    'UTC-11:00' => '(UTC-11:00) Niue, Samoa',
    'UTC-10:00' => '(UTC-10:00) Hawaii-Aleutian, Cook Island',
    'UTC-09:30' => '(UTC-09:30) Marquesas Islands',
    'UTC-09:00' => '(UTC-09:00) Alaska, Gambier Island',
    'UTC-08:30' => '(UTC-08:30) Pitcairn Islands',
    'UTC-08:00' => '(UTC-08:00) Pacific',
    'UTC-07:00' => '(UTC-07:00) Mountain',
    'UTC-06:00' => '(UTC-06:00) Central',
    'UTC-05:00' => '(UTC-05:00) Eastern',
    'UTC-04:00' => '(UTC-04:00) Atlantic',
    'UTC-03:30' => '(UTC-03:30) Newfoundland',
    'UTC-03:00' => '(UTC-03:00) Amazon, Central Greenland',
    'UTC-02:00' => '(UTC-02:00) Mid-Atlantic',
    'UTC-01:00' => '(UTC-01:00) Azores, Cape Verde, Eastern Greenland',
    'UTC' => '(UTC) Western European, Greenwich',
    'UTC+01:00' => '(UTC+01:00) Central European, West African',
    'UTC+02:00' => '(UTC+02:00) Eastern European, Central African',
    'UTC+03:00' => '(UTC+03:00) Eastern African',
    'UTC+03:30' => '(UTC+03:30) Iran',
    'UTC+04:00' => '(UTC+04:00) Moscow, Gulf, Samara',
    'UTC+04:30' => '(UTC+04:30) Afghanistan',
    'UTC+05:00' => '(UTC+05:00) Pakistan',
    'UTC+05:30' => '(UTC+05:30) India, Sri Lanka',
    'UTC+05:45' => '(UTC+05:45) Nepal',
    'UTC+06:00' => '(UTC+06:00) Bangladesh, Bhutan, Yekaterinburg',
    'UTC+06:30' => '(UTC+06:30) Cocos Islands, Myanmar',
    'UTC+07:00' => '(UTC+07:00) Indochina, Novosibirsk',
    'UTC+08:00' => '(UTC+08:00) Greater China, Australian Western, Krasnoyarsk',
    'UTC+08:45' => '(UTC+08:45) Southeastern Western Australia',
    'UTC+09:00' => '(UTC+09:00) Japan, Korea, Chita, Irkutsk',
    'UTC+09:30' => '(UTC+09:30) Australian Central',
    'UTC+10:00' => '(UTC+10:00) Australian Eastern',
    'UTC+10:30' => '(UTC+10:30) Lord Howe',
    'UTC+11:00' => '(UTC+11:00) Solomon Island, Vladivostok',
    'UTC+11:30' => '(UTC+11:30) Norfolk Island',
    'UTC+12:00' => '(UTC+12:00) New Zealand, Fiji, Magadan',
    'UTC+12:45' => '(UTC+12:45) Chatham Islands',
    'UTC+13:00' => '(UTC+13:00) Tonga, Phoenix Islands, Kamchatka',
    'UTC+14:00' => '(UTC+14:00) Line Islands',
    
    // Timeout Section
    'Timeouts subhead' => 'Time and timeouts',
    'Time format label' => 'Time format',
    'PHP manual' => 'PHP manual',
    'Time format help' => '[Current format: %s]. See <a href="http://www.php.net/manual/en/function.date.php">%s</a> for formatting options.',
    'Date format label' => 'Date format',
    'Date format help' => '[Current format: %s]. See <a href="http://www.php.net/manual/en/function.date.php">%s</a> for formatting options.',
    'Visit timeout label' => 'Visit timeout',
    'Visit timeout help' => 'Number of seconds a user must be idle before his/hers last visit data is updated (primarily affects new message indicators).',
    'Online timeout label' => 'Online timeout',
    'Online timeout help' => 'Number of seconds a user must be idle before being removed from the online users list.',
    'Redirect time label' => 'Redirect time',
    'Redirect time help' => 'Number of seconds to wait when redirecting. If set to 0, no redirect page will be displayed (not recommended).',
    
    // Cookies & Authentication Section
    'Cookie subhead' => 'Cookies and authentication',
    'Cookie name label' => 'Cookie Name',
    'Cookie domain label' => 'Cookie Domain',
    'Cookie name help' => 'This is the name of the cookie which will be used for authentication. Note that changing this value may log you out.',
    'Cookie seed label' => 'Cookie Seed',
    'Cookie domain help' => 'The domain which the cookie is valid. Sub-domains are automatically included by referencing the main domain here.',
    'Cookie secure label' => 'Cookie Secure',
    'Cookie secure help' => 'Whether or not to set the cookie through SSL (https). If there is no SSL connection or SSL is not always enforced, disable this option.',
    'Cookie seed help' => 'The random text which is added to the cookie in order to keep it secure and prevent session hijacking attacks.',
    'Cookie path label' => 'Cookie Path',
    'Cookie path help' => 'The path from which the cookie is accessible. By default, the cookie is accessible through all directories.',
    
    // Display Section
    'Display subhead' => 'Display',
    'Version number label' => 'Version number',
    'Version number help' => 'Show Panther version number in footer.',
    'Info in posts label' => 'User info in posts',
    'Info in posts help' => 'Show information about the poster under the username in topic view. The information affected is location, register date, post count and the contact links (email and URL).',
    'Post count label' => 'User post count',
    'Post count help' => 'Show the number of posts a user has made (affects topic view, profile and user list).',
    'Smilies label' => 'Smilies in posts',
    'Smilies help' => 'Convert smilies to small graphic icons.',
    'Smilies directory label' => 'Smilies URL',
    'Smilies directory help' => 'This field can be used if you store smilies in a different place from the Panther root, for example a content delivery network (ie. cdn.mydomain.com/assets/images/smilies/ instead of mydomain.com/forums/). Leave this blank if the location of smilies are relative to the Panther root.',
    'Img directory label' => 'Images URL',
    'Img directory help' => 'This field can be used if you store images in a different place from the Panther root, for example a content delivery network (ie. cdn.mydomain.com/assets/images/). Leave this blank if the location of images are relative to the Panther root.',
    'Img path label' => 'Image path',
    'Img path help' => 'This field is used when uploading image to the image root directory. Use a relative path to the Panther root unless the field below is filled in.',
    'JS directory label' => 'Javascript URL',
    'JS directory help' => 'Use this field if javascript scripts is stored in a separate place from the forum like images. Leave blank if the location of javascript files are relative to the Panther root.',
    'Smilies path label' => 'Smilies Path',
    'Smilies path help' => 'The absolute directory on the server where smilies are stored (relative or absolute if the field below is filled in). This must be correct for smiley uploads to work.',
    'Image group path label' => 'Group image path',
    'Image group path help' => 'The absolute directory on the server where group images are stored (relative or absolute if the field below is filled in). This must be correct for group image uploads to work.',
    'Image group dir label' => 'Group image URL',
    'Image group dir help' => 'Use this field if group images are stored in a separate place from the forum. Leave blank if the location of group images are relative to the Panther root.',
    'Max width group help' => 'The maximum allowed width of group images in pixels (60 is recommended).',
    'Max height group help' => 'The maximum allowed height of group images in pixels (30 is recommended).',
    'Max size group help' => 'The maximum allowed size of group images in bytes (10240 is recommended).',
    'Smilies sigs label' => 'Smilies in signatures',
    'Smilies sigs help' => 'Convert smilies to small graphic icons in user signatures.',
    'Clickable links label' => 'Make clickable links',
    'Clickable links help' => 'When enabled, Panther will automatically detect any URLs in posts and make them clickable hyperlinks.',
    'Topic review label' => 'Topic review',
    'Topic review help' => 'Maximum number of posts to display when posting (newest first). Set to 0 to disable.',
    'Topics per page label' => 'Topics per page',
    'Topics per page help' => 'The default number of topics to display per page in a forum. Users can personalize this setting.',
    'Posts per page label' => 'Posts per page',
    'Posts per page help' => 'The default number of posts to display per page in a topic. Users can personalize this setting.',
    'Indent label' => 'Indent size',
    'Indent help' => 'If set to 8, a regular tab will be used when displaying text within the [code][/code] tag. Otherwise this many spaces will be used to indent the text.',
    'Quote depth label' => 'Maximum [quote] depth',
    'Quote depth help' => 'The maximum times a [quote] tag can go inside other [quote] tags, any tags deeper than this will be discarded.',
    'User tags label' => 'Maximum [user] tags',
    'User tags help' => 'The maximum amount of [user] tags parsed per post. A large number is not recommended due to the fact each distinctive tag on a page requires a query of the database.',
    'Ban email label' => 'Email banned users',
    'Ban email help' => 'Email users when banned explaining why they have been banned.',
    'Style path label' => 'Style path',
    'Style path help' => 'This field is used when checking for CSS files. This should be relative to the Panther root or absolute if the field below is used.',
    'Style directory label' => 'Style URL',
    'Style directory help' => 'Use this field if CSS scripts is stored in a separate place from the forum. Leave blank if the location of CSS files are relative to the Panther root (and in the default location).',
    'Cloudflare email label' => 'CloudFlare email',
    'Cloudflare email help' => 'Specify your CloudFlare email here to cache files on your CDN. Leave blank for none.',
    'Cloudflare domain label' => 'CloudFlare domain',
    'Cloudflare domain help' => 'Use this field for the domain which is using CloudFlare. This can be a CDN or the base URL (domain only including trailing slash). Leave blank for none.',
    'Invalid cloudflare e-mail message' => 'The cloudflare email address you entered is invalid.',
    
    // Features section
    'Features subhead' => 'Features',
    'Quick post label' => 'Quick reply',
    'Quick post help' => 'When enabled, Panther will add a quick reply form at the bottom of topics. This way users can post directly from the topic view.',
    'Users online label' => 'Users online',
    'Users online help' => 'Display info on the index page about guests and registered users currently browsing the board.',
    'Archive label' => 'Archiving',
    'Archive help' => 'Archive topics in order to preserve the information inside them. See <a href="%s">Archiving</a> for more.',
    'Warning label' => 'Warnings',
    'Warning help' => 'Allow moderators to warn users. You can choose which user groups are allowed to warn users.',
    'Warning custom label' => 'Custom warnings',
    'Warning custom help' => 'Allow moderators to issue custom warnings.',
    'Warning status label' => 'Warnings visibility',
    'Warning status help' => 'Determines who can see the warning level of users on the forum.',
    'All users' => 'All users',
    'Moderators and warned' => 'Moderators and warned users',
    'Moderators only' => 'Moderators only',
    'Censor words label' => 'Censor words',
    'Censor words help' => 'Enable this to censor specific words in the board. See <a href="%s">%s</a> for more info.',
    'Signatures label' => 'Signatures',
    'Signatures help' => 'Allow users to attach a signature to their posts.',
    'User ranks label' => 'User ranks',
    'User ranks help' => 'Enable this to use user ranks. See <a href="%s">%s</a> for more info.',
    'User has posted label' => 'User has posted earlier',
    'User has posted help' => 'This feature displays a dot in front of topics in viewforum.php in case the currently logged in user has posted in that topic earlier. Disable if you are experiencing high server load.',
    'Topic views label' => 'Topic views',
    'Topic views help' => 'Keep track of the number of views a topic has. Disable if you are experiencing high server load in a busy forum.',
    'Quick jump label' => 'Quick jump',
    'Quick jump help' => 'Enable the quick jump (jump to forum) drop list.',
    'GZip label' => 'GZip output',
    'GZip help' => 'If enabled, Panther will gzip the output sent to browsers. This will reduce bandwidth usage, but use a little more CPU. This feature requires that PHP is configured with zlib (--with-zlib). Note: If you already have one of the Apache modules mod_gzip or mod_deflate set up to compress PHP scripts, you should disable this feature.',
    'Search all label' => 'Search all forums',
    'Search all help' => 'When disabled, searches will only be allowed in one forum at a time. Disable if server load is high due to excessive searching.',
	'Task type label' => 'Cron Jobs',
    'Task type help' => 'When disabled, tasks will be ran on page load rather than cron jobs. This will only enable if the function \'exec\' is enabled on your server. See <a href="%s">Tasks</a> for more.',
    'Menu items label' => 'Additional menu items',
    'Menu items help' => 'By entering links into this textbox, any number of items can be added to the navigation menu at the top of all pages. The format for adding new links is X = URL|LINK where X is the position at which the link should be inserted (e.g. 0 to insert at the beginning and 2 to insert after "User list"). Separate entries with a linebreak.',
    'Rep abuse label' => 'Reputation Abuse',
    'Rep abuse help' => 'The number of consecutive negative votes a user must issue to detect potential reputation abuse. Detected reputation abuse will be sent to the mailing list. Set to 0 to disable.',
    'Reputation label' => 'Reputation',
    'Reputation help' => 'If enabled, users will be able to give reputation to each other. You can restrict the permissions on a user-group per basis.',
    'Rep type label' => 'Reputation type',
    'Rep type help' => 'The votes available for users who are allowed to use the reputation system.',
    'Positive and negative' => 'Positive and negative',
    'Positive only' => 'Positive only',
    'Negative only' => 'Negative only',
    'PM help' => 'Allow users to send private messages to each other (these can be configured on a per user-group basis).',
    'PM label' => 'Private Messaging',
    'Login queue label' => 'Queue login attempts',
    'Login queue help' => 'If enabled, login attempts will be queued as a means of preventing brute-force attacks against the forum. Disable if you are experiencing high server load in a busy forum.',
    'Queue size label' => 'Max queue size',
    'Queue size help' => 'The maximum size of the login queue for all users. Any attempts to login after this will be given a message until the queue goes down slightly.',
    'Max attempts label' => 'Max attempts',
    'Max attempts help' => 'The maximum number of login attempts per username. Any attempts greater than this will receive a message stating the queue is full.',
	'Update type label' => 'Update format',
	'Neither' => 'Do not download or install (not recommended)',
	'Install only' => 'Install pre-downloaded updates only',
	'Download only' => 'Download but manually install (recommended)',
	'Download and install' => 'Download and install',
    'Update type help' => 'Choose the format of how you want updates to your forum to be installed.',
    'Debug mode label' => 'Debug mode',
    'Debug mode help' => 'If enabled, query information will be shown at the bottom of every page, and other useful information. Additionally, templates will be re-parsed on every page view so the server load may temporarily increase. <strong>Note:</strong> Debug mode is only intended for debugging and should be turned off again when you are done with debugging.',
    'Show queries label' => 'Show query information',
    'Show queries help' => 'This option will add query information to the bottom of every page. <strong>Note:</strong> This will display all the queries for that page to all users. It is strongly recommended this be turned off when finished debugging.',
    'SFS api key' => 'SFS API Key',
    'SFS api key help' => 'You can specify an API key here from <a href="https://www.stopforumspam.com">Stop Forum Spam</a> which will allow you to report posts as spam when deleting them.',
    'Tinypng api' => 'TinyPNG API Key',
    'Tinypng api help' => 'You can specify an API Key here from <a href="https://tinypng.com">TinyPNG</a> which will compress all uploaded JPEG and PNG images to save server space and reduce bandwidth. Leave blank for none.',
    'Cloudflare api' => 'Cloudflare API Key',
    'Cloudflare api help' => 'You can specify an API Key here from <a href="https://cloudflare.com">Cloudflare</a> which will allow you to update caches (if your forum is using Cloudflare\'s CDN). Leave blank for none.',
    
    // Feeds section
    'Feed subhead' => 'Syndication',
    'Default feed label' => 'Default feed type',
    'Default feed help' => 'Select the type of syndication feed to display. Note: Choosing none will not disable feeds, only hide them by default.',
    'None' => 'None',
    'RSS' => 'RSS',
    'Atom' => 'Atom',
    'Feed TTL label' => 'Duration to cache feeds',
    'Feed TTL help' => 'Feeds can be cached to lower the resource usage of feeds.',
    'No cache' => 'Don\'t cache',
    'Minutes' => '%d minutes',
    
    // Reports section
    'Reports subhead' => 'Reports',
    'Reporting method label' => 'Reporting method',
    'Internal' => 'Internal',
    'By e-mail' => 'Email',
    'Both' => 'Both',
    'Reporting method help' => 'Select the method for handling topic/post reports. You can choose whether topic/post reports should be handled by the internal report system, emailed to the addresses on the mailing list (see below) or both.',
    'Mailing list label' => 'Mailing list',
    'Mailing list help' => 'A comma separated list of subscribers. The people on this list are the recipients of reports.',
    
    // Avatars section
    'Avatars subhead' => 'Avatars',
    'Use avatars label' => 'Use avatars',
    'Use avatars help' => 'When enabled, users will be able to upload an avatar which will be displayed under their title/rank.',
    'Avatar upload label' => 'Enable Upload',
    'Avatar upload help' => 'Allow users to upload an avatar of their choice. If set to no, they will only be allowed to use <a href="https://en.gravatar.com/">gravatar</a>.',
    'Upload directory label' => 'Avatars URL',
    'Move failed' => 'The server was unable to save the uploaded file. Please contact the forum administrator at',
    'Upload directory help' => 'This field can be used if you store avatars in a different place from the panther root, for example a content delivery network (ie. cdn.mydomain.com/assets/images/avatars/ instead of mydomain.com/forums/). Leave this blank if the location of avatars are reletave to the Panther root.',
    'Avatars path label' => 'Upload directory',
    'Avatars path help' => 'The upload directory for avatars (relative or absolute if the field below is filled in). PHP must have write permissions to this directory.',
    'Max width label' => 'Max width',
    'Max width help' => 'The maximum allowed width of avatars in pixels (150 is recommended).',
    'Max height label' => 'Max height',
    'Max height help' => 'The maximum allowed height of avatars in pixels (150 is recommended).',
    'Max size label' => 'Max size',
    'Max size help' => 'The maximum allowed size of avatars in bytes (100000 is recommended).',
    
    'Max width smilies label' => 'Max smiley width',
    'Max width smilies help' => 'The maximum allowed width of smilies uploaded in pixels (20 is recommended).',
    'Max height smilies label' => 'Max smiley height',
    'Max height smilies help' => 'The maximum allowed height of smilies in pixels (20 is recommended).',
    'Max size smilies label' => 'Max smiley size',
    'Max size smilies help' => 'The maximum allowed size of smilies in bytes (10240 is recommended).',
    
    // E-mail section
    'E-mail subhead' => 'Email',
    'Admin e-mail label' => 'Admin email',
    'Admin e-mail help' => 'The email address of the board administrator.',
    'Webmaster e-mail label' => 'Webmaster email',
    'Webmaster e-mail help' => 'This is the address that all emails sent by the board will be addressed from.',
    'E-mail name label' => 'Email name',
    'E-mail name help' => 'The name which emails sent from the board will be addressed from (ie. My Company). This field should contain characters of only a-z, A-Z or 0-9.',
    'Forum subscriptions label' => 'Forum subscriptions',
    'Forum subscriptions help' => 'Enable users to subscribe to forums (receive email when someone creates a new topic).',
    'Topic subscriptions label' => 'Topic subscriptions',
    'Topic subscriptions help' => 'Enable users to subscribe to topics (receive email when someone replies).',
    'SMTP address label' => 'SMTP server address',
    'SMTP address help' => 'The address of an external SMTP server to send emails with. You can specify a custom port number if the SMTP server doesn\'t run on the default port 25 (example: mail.myhost.com:3580). Leave blank to use the local mail program.',
    'SMTP username label' => 'SMTP username',
    'SMTP username help' => 'Username for SMTP server. Only enter a username if it is required by the SMTP server (most servers <strong>do not</strong> require authentication).',
    'SMTP password label' => 'SMTP password',
    'SMTP change password help' => 'Check this if you want to change or delete the currently stored password.',
    'SMTP password help' => 'Password for SMTP server. Only enter a password if it is required by the SMTP server (most servers <strong>do not</strong> require authentication). Please enter your password twice to confirm.',
    'SMTP SSL label' => 'Encrypt SMTP using SSL',
    'SMTP SSL help' => 'Encrypts the connection to the SMTP server using SSL. Should only be used if your SMTP server requires it and your version of PHP supports SSL.',
    
    // Registration Section
    'Registration subhead' => 'Registration',
    'Allow new label' => 'Allow new registrations',
    'Allow new help' => 'Controls whether this board accepts new registrations. Disable only under special circumstances.',
    'Verify label' => 'Verify registrations',
    'Verify help' => 'When enabled, users are emailed a random password when they register. They can then log in and change the password in their profile if they see fit. This feature also requires users to verify new email addresses if they choose to change from the one they registered with. This is an effective way of avoiding registration abuse and making sure that all users have "correct" email addresses in their profiles.',
    'Report new label' => 'Report new registrations',
    'Report new help' => 'If enabled, Panther will notify users on the mailing list (see above) when a new user registers in the forums.',
    'Use rules label' => 'User forum rules',
    'Use rules help' => 'When enabled, users must agree to a set of rules when registering (enter text below). The rules will always be available through a link in the navigation table at the top of every page.',
    'Rules label' => 'Enter your rules here',
    'Rules help' => 'Here you can enter any rules or other information that the user must review and accept when registering. If you enabled rules above you have to enter something here, otherwise it will be disabled. This text will not be parsed like regular posts and thus may contain HTML.',
    'E-mail default label' => 'Default email setting',
    'E-mail default help' => 'Choose the default privacy setting for new user registrations.',
    'Display e-mail label' => 'Display email address to other users.',
    'Hide allow form label' => 'Hide email address but allow form e-mail.',
    'Hide both label' => 'Hide email address and disallow form email.',
    
    // Announcement Section
    'Announcement subhead' => 'Announcements',
    'Display announcement label' => 'Display announcement',
    'Display announcement help' => 'Enable this to display the below message in the board.',
    'Announcement message label' => 'Announcement message',
    'Announcement message help' => 'This text will not be parsed like regular posts and thus may contain HTML.',
    
    // Maintenance Section
    'Maintenance subhead' => 'Maintenance',
    'Maintenance mode label' => 'Maintenance mode',
    'Maintenance mode help' => 'When enabled, the board will only be available to administrators. This should be used if the board needs to be taken down temporarily for maintenance. <strong>WARNING! Do not log out when the board is in maintenance mode.</strong> You will not be able to login again.',
    'Maintenance message label' => 'Maintenance message',
    'Maintenance message help' => 'The message that will be displayed to users when the board is in maintenance mode. If left blank, a default message will be used. This text will not be parsed like regular posts and thus may contain HTML.'
    
);