<?php

// Language definitions used in install.php, localized by adaur

$lang_install = array(
    
    'Choose install language' => 'Choose the install script language',
    'Choose install language info' => 'The language used for this install script. The default language used for the board itself can be set below.',
    'Install language' => 'Install language',
    'Change language' => 'Change language',
    'Already installed' => 'It seems like Panther is already installed. You should go <a href="index.php">here</a> instead.',
    'You are running error' => 'You are running MySQL version %2$s. Panther %3$s requires at least MySQL %4$s to run properly. You must upgrade your MySQL installation before you can continue.',
    'My Panther Forum' => 'My Panther Forum',
    'Description' => 'Panther &mdash; <em>the dawn of a new age in forum software</em>.',
    'Username 1' => 'Usernames must be at least 2 characters long.',
    'Username 2' => 'Usernames must not be more than 25 characters long.',
    'Username 3' => 'The username guest is reserved.',
    'Username 4' => 'Usernames may not be in the form of an IP address.',
    'Username 5' => 'Usernames may not contain all the characters \', " and [ or ] at once.',
    'Username 6' => 'Usernames may not contain any of the text formatting tags (BBCode) that the forum uses.',
    'admin notes' => 'You can use this section to keep notes for other users who access the Admin CP. It is globally editable by all staff who have access to the dashboard.',
    'Short password' => 'Passwords must be at least 6 characters long.',
    'Passwords not match' => 'Passwords do not match.',
    'Wrong email' => 'The administrator email address you entered is invalid.',
    'No board title' => 'You must enter a board title.',
    'Error default language' => 'The default language chosen doesn\'t seem to exist.',
    'Error default style' => 'The default style chosen doesn\'t seem to exist.',
    'No DB extensions' => 'This PHP environment does not have support for any of the databases or PHP extensions which Panther supports. PHP needs to have support for either MySQL as well as PDO in order for Panther to be installed.',
    'Administrator username' => 'Administrator\'s username',
    'Administrator email' => 'Administrator\'s email',
    'Board title' => 'Board title',
    'Base URL' => 'The URL (without trailing slash) of your Panther forum. This must be correct.',
    'Required field' => 'is a required field in this form.',
    'Panther Installation' => 'Panther Installation',
    'Welcome' => 'You are about to install Panther. In order to install Panther, you must complete the form set out below. If you encounter any difficulties with the installation, please refer to the documentation.',
    'Install' => 'Install Panther %s',
    'Errors' => 'The following errors need to be corrected:',
    'Database setup' => 'Database setup',
    'Info 1' => 'All information we need to create a connection with your database.',
    'sha512 not supported' => 'It seems sha512 has been disabled on your server (or at least you don\'t support it). Please enable the sha512 hashing algorithm and try again.',
    'Email name problem' => 'The board name you entered was unable to be converted into a valid email name. Try again, including only characters of a-z, A-Z or 0-9.',
    'New' => 'New',
    'Inbox' => 'Inbox',
    'Archived' => 'Archived',
    'Required' => '(Required)',
    'Database hostname' => 'Enter your database server hostname',
    'Info 3' => 'You should be able to get this info from your web host, if <code>localhost</code> does not work.',
    'Database server hostname' => 'Database server hostname',
    'Database enter name' => 'Enter the name of your database',
    'Info 4' => 'The name of the database you want to install Panther on.',
    'Database name' => 'Database name',
    'Database enter informations' => 'Enter your database username and password',
    'Database username' => 'Database username',
    'Info 5' => 'Your MySQL username and password.',
    'Database password' => 'Database password',
    'Database enter prefix' => 'Enter database table prefix',
    'Info 6' => 'If you want to run multiple Panther installations in a single database, change this.',
    'Table prefix' => 'Table prefix',
    'Administration setup' => 'Administration setup',
    'Info 7' => 'Create the very first account on your board.',
    'Info 8' => 'Your username should be between 2 and 25 characters long. Your password must be at least 6 characters long. Remember that passwords are case-sensitive.',
    'Password' => 'Password',
    'Confirm password' => 'Confirm password',
    'Board setup' => 'Board setup',
    'Info 11' => 'Settings for your board. You can change this later.',
    'General information' => 'Enter your board\'s title and description.',
    'Board description' => 'Board description (supports HTML)',
    'Cookie setup' => 'Board cookies',
    'Info 19' => 'Cookie settings for your board.',
    'Cookie name' => 'Cookie name',
    'Cookie seed' => 'Cookie seed',
    'Appearance' => 'Appearance',
    'Info 15' => 'Make your forum yours. Choose a language and a style for your board.',
    'Default language' => 'Default language',
    'Default style' => 'Default style',
    'Start install' => 'Start install',
    'DB type not valid' => '\'%s\' is not a valid database type',
    'Table prefix error' => 'The table prefix \'%s\' contains illegal characters or is too long. The prefix may contain the letters a to z, any numbers and the underscore character. They must however not start with a number. The maximum length is 40 characters. Please choose a different prefix',
    'Prefix reserved' => 'The table prefix \'sqlite_\' is reserved for use by the SQLite engine. Please choose a different prefix',
    'Existing table error' => 'A table called \'%susers\' is already present in the database \'%s\'. This could mean that Panther is already installed or that another piece of software is installed and is occupying one or more of the table names Panther requires. If you want to install multiple copies of Panther in the same database, you must choose a different table prefix',
    'Administrators' => 'Administrators',
    'Administrator' => 'Administrator',
    'Global Moderators' => 'Global Moderators',
    'Global Moderator' => 'Global Moderator',
    'Moderators' => 'Moderators',
    'Moderator' => 'Moderator',
    'Guests' => 'Guests',
    'Guest' => 'Guest',
    'New members' => 'New Members',
    'New member' => 'New Member',
    'Member' => 'Member',
    'Members' => 'Members',
    'Announcement' => 'Enter your announcement here.',
    'Rules' => 'Enter your rules here.',
    'Maintenance message' => 'The forums are down for temporary maintenance. Please try again in a few minutes.',
    'Test post' => 'Welcome to Panther %s',
    'Message' => 'Thank you for choosing Panther for your community, we know you\'re going to love it.'."\n\n".'Before you get started, take some time to look through the available [url=https://www.pantherforum.org/docs/]docmentation[/url]. In particular, we recommend the getting started documentation which will walk you through the necessary steps of setting up your forum.'."\n\n".'You can download additional language packs, URL schemes, styles, addons and plugins from [url=https://www.pantherforum.org/]the panther website[/url], and please post bug reports using our [url=https://www.pantherforum.org/support/]support centre[/url].'."\n\n".'Now log in and head over to the administration control panel to configure your forum! The username and password requested when you attempt to administer the board is your own.'."\n\n".'Thank you for your continued support! :)',
    'Test category' => 'Test category',
    'Test forum' => 'Test forum',
    'This is just a test forum' => 'This is just a test forum',
    'Alert cache' => '<strong>The cache directory is currently not writable!</strong> In order for Panther to function properly, the directory <em>%s</em> must be writable by PHP. Use chmod to set the appropriate directory permissions. If in doubt, chmod to 0777.',
    'Alert avatar' => '<strong>The avatar directory is currently not writable!</strong> If you want users to be able to upload their own avatar images you must see to it that the directory <em>%s</em> is writable by PHP. You can later choose to save avatar images in a different directory (see Admin/Options). Use chmod to set the appropriate directory permissions. If in doubt, chmod to 0777.',
    'Alert upload' => '<strong>File uploads appear to be disallowed on this server!</strong> If you want users to be able to upload their own avatar images you must enable the file_uploads configuration setting in PHP. Once file uploads have been enabled, avatar uploads can be enabled in Administration/Options/Features. Note that users will still be given the option of using Gravatar.',
    'Tasks alert' => 'You appear to be running on a Windows server, or at least do not have access to the function \'exec\'. For this reason, background processes have been switched to run on page load (not recommended).',
	'Panther has been installed' => 'Panther has been installed. To finalise the installation please follow the instructions below.',
    'Final instructions' => 'Final instructions',
    'Info 17' => 'To finalise the installation, you need to click on the button below to download a file called config.php. You then need to upload this file to the directory \'include\' of your Panther installation.',
    'Info 18' => 'Once you have uploaded config.php, Panther will be fully installed! At that point, you may <a href="index.php">go to the forum index</a>.',
    'Download config.php file' => 'Download config.php file',
    'Panther fully installed' => 'Panther has been fully installed! You may now <a href="index.php">go to the forum index</a>.',
    'Task title' => 'Check and install updates',
);